diff --git a/drivers/display/Kconfig.ssd1306 b/drivers/display/Kconfig.ssd1306
index 506525b4d3c4f..d496bdb690e85 100644
--- a/drivers/display/Kconfig.ssd1306
+++ b/drivers/display/Kconfig.ssd1306
@@ -35,4 +35,12 @@ config SSD1306_SH1106_COMPATIBLE
 
 endchoice
 
+config SSD1306_MAX_I2C_TRANSFER_SIZE
+	int "Maximum I2C transfer size"
+	range 1 8192
+	default 255 if I2C_STM32
+	default 8192
+	help
+	  Maximum size of an I2C message that can be transferred
+
 endif #SSD1306
diff --git a/drivers/display/ssd1306.c b/drivers/display/ssd1306.c
index f307b57c15e3c..3f3c33378010b 100644
--- a/drivers/display/ssd1306.c
+++ b/drivers/display/ssd1306.c
@@ -177,6 +177,34 @@ int ssd1306_suspend(const struct device *dev)
 				 SSD1306_DISPLAY_OFF);
 }
 
+static int ssd1306_i2c_data_write(const struct device *dev, const u8_t *data,
+				  size_t length)
+{
+	int err;
+	u8_t cmd;
+	u32_t cur_length;
+	struct ssd1306_data *driver = dev->driver_data;
+
+	do {
+		if (length > CONFIG_SSD1306_MAX_I2C_TRANSFER_SIZE) {
+			cur_length = CONFIG_SSD1306_MAX_I2C_TRANSFER_SIZE;
+			length -= CONFIG_SSD1306_MAX_I2C_TRANSFER_SIZE;
+			cmd = SSD1306_CONTROL_BYTE_DATA;
+		} else {
+			cur_length = length;
+			length = 0;
+			cmd = SSD1306_CONTROL_LAST_BYTE_DATA;
+		}
+		err = i2c_burst_write(driver->i2c,
+				      DT_SOLOMON_SSD1306FB_0_BASE_ADDRESS,
+				      cmd, data, length);
+
+	} while ((err == 0) && (length > 0));
+
+	return err;
+}
+
+
 int ssd1306_write_page(struct device *dev, u8_t page, void * const data,
 		       size_t length)
 {
@@ -213,9 +241,7 @@ int ssd1306_write_page(struct device *dev, u8_t page, void * const data,
 		return -1;
 	}
 
-	return i2c_burst_write(driver->i2c, DT_SOLOMON_SSD1306FB_0_BASE_ADDRESS,
-			       SSD1306_CONTROL_LAST_BYTE_DATA,
-			       data, length);
+	return ssd1306_i2c_data_write(dev, data, length);
 }
 
 int ssd1306_write(const struct device *dev, const u16_t x, const u16_t y,
@@ -270,9 +296,7 @@ int ssd1306_write(const struct device *dev, const u16_t x, const u16_t y,
 		return -1;
 	}
 
-	return i2c_burst_write(driver->i2c, DT_SOLOMON_SSD1306FB_0_BASE_ADDRESS,
-			       SSD1306_CONTROL_LAST_BYTE_DATA,
-			       (u8_t *)buf, desc->buf_size);
+	return ssd1306_i2c_data_write(dev, buf, desc->buf_size);
 
 #elif defined(CONFIG_SSD1306_SH1106_COMPATIBLE)
 	if (len != SSD1306_PANEL_NUMOF_PAGES * DT_SOLOMON_SSD1306FB_0_WIDTH) {
